#include <glib.h>
#include "df-object.h"
#include "df-lamp.h"

/*
 * Methods
 */
DF__Lamp *
DF__Lamp__construct(DF__Lamp *self, gboolean state)
{
	g_return_val_if_fail(self != NULL, NULL);
	g_return_val_if_fail(DF__IS_A(self, DF__Lamp), NULL);

	self->state = state;

	return self;
}

void
DF__Lamp__turn_off(DF__Lamp *self)
{
	g_return_if_fail(self != NULL);
	g_return_if_fail(DF__IS_A(self, DF__Lamp));

	self->state = FALSE;
}

void
DF__Lamp__turn_on(DF__Lamp *self)
{
	g_return_if_fail(self != NULL);
	g_return_if_fail(DF__IS_A(self, DF__Lamp));

	self->state = TRUE;
}

/* Overriding function */
static void
destroy(DF__Lamp *self)
{
	/* Here we do destruction */
	self->state = FALSE;

	/* Call parent implementation */
	DF__CALL_VIRTUAL(DF__Lamp__ParentVirtuals, void,
			 destroy, (DF__UCAST(self, DF__Object)), 0);
}

/*
 * Init functions
 */
static void
init_virtuals(DF__Lamp__Virtuals *virtuals)
{
	/* overrides */
	virtuals->destroy = destroy;

	/* our virtuals would be setup here */
}

static void
init_interfaces(DF__Lamp__Interfaces *interfaces)
{
}

static void
init_data(DF__Lamp *self)
{
	self->state = FALSE;
}

/*
 * Definitions macro
 */
DF__DEFINITIONS(DF__Lamp, DF__Object, init_virtuals, init_interfaces, init_data)
